Bug 773626 - Failed to load resource composite data error when refreshing Inventory page (Unavailable Servers, Servers, etc)
Failed to load resource composite data error when refreshing Inventory page (...
Status: CLOSED CURRENTRELEASE
Product: RHQ Project
Classification: Other
Component: Core UI (Show other bugs)
4.2
All All
high Severity high (vote)
: ---
: RHQ 4.9
Assigned To: RHQ Project Maintainer
Mike Foley
:
Depends On:
Blocks: 851288
  Show dependency treegraph
 
Reported: 2012-01-12 08:07 EST by claprun
Modified: 2014-03-26 04:31 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 851288 (view as bug list)
Environment:
Last Closed: 2014-03-26 04:31:22 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
Inventory -> Servers Screen Shot - No Error (225.55 KB, image/png)
2012-08-23 13:08 EDT, Larry O'Leary
no flags Details
Inventory -> Servers Screen Shot after column resize - Error (111.60 KB, image/png)
2012-08-23 13:09 EDT, Larry O'Leary
no flags Details
PageList was passed an empty collection but 'totalSize' was 4 (238.66 KB, image/jpeg)
2013-04-30 12:50 EDT, vlad crc
no flags Details

  None (edit)
Description claprun 2012-01-12 08:07:11 EST
java.lang.RuntimeException:[1326373428381] javax.ejb.EJBException:java.lang.IllegalArgumentException: PageList was passed an empty collection but 'totalSize' was 1, PageControl[firstRow=42, size=50] -> java.lang.IllegalArgumentException:PageList was passed an empty collection but 'totalSize' was 1, PageControl[firstRow=42, size=50]
--- STACK TRACE FOLLOWS ---
[1326373428381] javax.ejb.EJBException:java.lang.IllegalArgumentException: PageList was passed an empty collection but 'totalSize' was 1, PageControl[firstRow=42, size=50] -> java.lang.IllegalArgumentException:PageList was passed an empty collection but 'totalSize' was 1, PageControl[firstRow=42, size=50]
   at Unknown.java_lang_RuntimeException_$RuntimeException__Ljava_lang_RuntimeException_2Ljava_lang_RuntimeException_2(Unknown source:0)
   at Unknown.com_google_gwt_user_client_rpc_core_java_lang_RuntimeException_1FieldSerializer_instantiate__Lcom_google_gwt_user_client_rpc_SerializationStreamReader_2Ljava_lang_RuntimeException_2(Unknown source:0)
   at Unknown.com_google_gwt_user_client_rpc_impl_SerializerBase$MethodMap_$instantiate__Lcom_google_gwt_user_client_rpc_impl_SerializerBase$MethodMap_2Lcom_google_gwt_user_client_rpc_SerializationStreamReader_2Ljava_lang_String_2Ljava_lang_Object_2(Unknown source:0)
   at Unknown.com_google_gwt_user_client_rpc_impl_SerializerBase_$instantiate__Lcom_google_gwt_user_client_rpc_impl_SerializerBase_2Lcom_google_gwt_user_client_rpc_SerializationStreamReader_2Ljava_lang_String_2Ljava_lang_Object_2(Unknown source:0)
   at Unknown.com_google_gwt_user_client_rpc_impl_AbstractSerializationStreamReader_$readObject__Lcom_google_gwt_user_client_rpc_impl_AbstractSerializationStreamReader_2Ljava_lang_Object_2(Unknown source:0)
   at Unknown.com_google_gwt_user_client_rpc_impl_RequestCallbackAdapter_$onResponseReceived__Lcom_google_gwt_user_client_rpc_impl_RequestCallbackAdapter_2Lcom_google_gwt_http_client_Request_2Lcom_google_gwt_http_client_Response_2V(Unknown source:0)
   at Unknown.org_rhq_enterprise_gui_coregui_client_util_rpc_TrackingRequestCallback_onResponseReceived__Lcom_google_gwt_http_client_Request_2Lcom_google_gwt_http_client_Response_2V(Unknow
Comment 1 claprun 2012-01-12 08:12:30 EST
Actually, the same happens also if I just click on unavailable server from the resource list on the left…
Comment 2 Lukas Krejci 2012-01-18 06:44:10 EST
I tried clicking on the "Unavailable servers" link in the main Inventory tab with both a server unavailable and no servers unavailable and I could not reproduce this. I also tried to click the "Refresh" button on that page and got no exceptions.

Are those correct repro-steps?

Btw. I tried this on RHQ-4.3.0-SNAPSHOT build 5b4ab4a.
Comment 3 Lukas Krejci 2012-01-18 10:17:55 EST
could not reproduce in build 81533f2 (the latest available at the time of writing this comment) either.
Comment 4 Ian Springer 2012-02-14 21:45:17 EST
This sounds very similar to https://bugzilla.redhat.com/show_bug.cgi?id=720490, which was fixed back on 10/14/11, but it's possible the fix didn't make it into RHQ 4.2, which was released on 10/31/11.
Comment 5 Larry O'Leary 2012-08-23 13:07:04 EDT
This issue can be seen in RHQ 4.4.0. I can see it in the Inventory -> Servers page. What I have come to realize and accept is that the problem will only appear when certain circumstances allow. Specifically:

- screen resolution
- number of resources in the list
- font size
- resource names
- width of browser window

I am able to reproduce the issue with 17 servers in inventory combined with: 
    * zooming in from the browser
    * or reducing the width of my web browser
    * or increasing the default font size
    * or changing default fonts
    * or changing screen resolutions 
    * or changing the width of the Ancestor or Description column to their minimum

In my case, I go to the server resources page and scroll to the bottom of the list and then click the Refresh button.

Depending on my zoom level, resolution, font size, browser window width, etch, the error message will change:

	

--- STACK TRACE FOLLOWS ---
[1345752450732] javax.ejb.EJBException:java.lang.IllegalArgumentException: PageList was passed an empty collection but 'totalSize' was 17, PageControl[firstRow=24, size=50] -> java.lang.IllegalArgumentException:PageList was passed an empty collection but 'totalSize' was 17, PageControl[firstRow=24, size=50]
   at Unknown.java_lang_RuntimeException_RuntimeException__V(Unknown Source)
   at Unknown.com_google_gwt_user_client_rpc_core_java_lang_RuntimeException_1FieldSerializer_instantiate__Lcom_google_gwt_user_client_rpc_SerializationStreamReader_2Ljava_lang_RuntimeException_2(Unknown Source)
   at Unknown.com_google_gwt_user_client_rpc_impl_SerializerBase$MethodMap_$instantiate__Lcom_google_gwt_user_client_rpc_impl_SerializerBase$MethodMap_2Lcom_google_gwt_user_client_rpc_SerializationStreamReader_2Ljava_lang_String_2Ljava_lang_Object_2(Unknown Source)
   at Unknown.com_google_gwt_user_client_rpc_impl_SerializerBase_$instantiate__Lcom_google_gwt_user_client_rpc_impl_SerializerBase_2Lcom_google_gwt_user_client_rpc_SerializationStreamReader_2Ljava_lang_String_2Ljava_lang_Object_2(Unknown Source)
   at Unknown.com_google_gwt_user_client_rpc_impl_AbstractSerializationStreamReader_$readObject__Lcom_google_gwt_user_client_rpc_impl_AbstractSerializationStreamReader_2Ljava_lang_Object_2(Unknown Source)
   at Unknown.com_google_gwt_user_client_rpc_impl_RequestCallbackAdapter_$onResponseReceived__Lcom_google_gwt_user_client_rpc_impl_RequestCallbackAdapter_2Lcom_google_gwt_http_client_Request_2Lcom_google_gwt_http_client_Response_2V(Unknown Source)
   at Unknown.org_rhq_enterprise_gui_coregui_client_util_rpc_TrackingRequestCallback_onResponseReceived__Lcom_google_gwt_http_client_Request_2Lcom_google_gwt_http_client_Response_2V(Unknown Source)
   at Unknown.com_google_gwt_http_client_Request_$fireOnResponseReceived__Lcom_google_gwt_http_client_Request_2Lcom_google_gwt_http_client_RequestCallback_2V(Unknown Source)
   at Unknown.com_google_gwt_http_client_RequestBuilder$1_onReadyStateChange__Lcom_google_gwt_xhr_client_XMLHttpRequest_2V(Unknown Source)
   at Unknown.anonymous(Unknown Source)
   at Unknown.com_google_gwt_core_client_impl_Impl_apply__Ljava_lang_Object_2Ljava_lang_Object_2Ljava_lang_Object_2Ljava_lang_Object_2(Unknown Source)
   at Unknown.com_google_gwt_core_client_impl_Impl_entry0__Ljava_lang_Object_2Ljava_lang_Object_2Ljava_lang_Object_2Ljava_lang_Object_2(Unknown Source)
   at Unknown.anonymous(Unknown Source)
   at Unknown.anonymous(Unknown Source)
   
   
   
Specifically, PageControl[firstRow=24, size=50] will change. Like PageControl[firstRow=19, size=49].




What appears to be happening here is that the row height might be to blame and is causing the dataset paging to be beyond the initial rendering of the control when the default row height is used.

I have attached a couple of screen-shots that show what my Inventory -> Servers page looks like in a working state vs. non-working state after I reduced the column width of the Ancestor and Description columns.
Comment 6 Larry O'Leary 2012-08-23 13:08:19 EDT
Created attachment 606658 [details]
Inventory -> Servers Screen Shot - No Error
Comment 7 Larry O'Leary 2012-08-23 13:09:02 EDT
Created attachment 606659 [details]
Inventory -> Servers Screen Shot after column resize - Error
Comment 9 Jirka Kremser 2012-08-31 07:08:45 EDT
Doesn't actually solve the purpose of the problem which is related with dynamic loading of data to ListGrid component performed automatically by SmartGWT (see https://bugzilla.redhat.com/show_bug.cgi?id=851288#c1). However, it handles the consequences.

NOTE: this commit can be reverted once the purpose of the problem is fixed

http://git.fedorahosted.org/cgit/rhq/rhq.git/diff/?id=e33404e

master
time:    Fri Aug 31 13:02:07 2012 +0200
commit:  e33404e91d4b0cfc681e7816872e93c107b5d8f5
author:  Jirka Kremser - jkremser@redhat.com
message: [BZ 773626 - Failed to load resource composite data error when refreshing Inventory page (Unavailable Servers, Servers, etc)] handling the exception on the client side and re-fetch the data
Comment 10 vlad crc 2013-04-30 12:49:05 EDT
Hi,

We also have this error in 4.4, occurs often in various pages where a "table" is involved. An example is in the screenshot attached, in alerts definitions page.
Our workaround is to refresh the browser page, or to navigate away to some other link and back, but sometimes the error stays there even after this steps and makes the user experience very annoying.

Best regards,
Vlad
Comment 11 vlad crc 2013-04-30 12:50:06 EDT
Created attachment 741927 [details]
PageList was passed an empty collection but 'totalSize' was 4
Comment 13 Lukas Krejci 2013-09-02 07:30:58 EDT
I believe this has the same underlying cause as BZ 855674. Pushing to ON_QA so that we can have it tested.
Comment 14 Heiko W. Rupp 2014-03-26 04:31:22 EDT
Bulk closing now that 4.10 is out.

If you think an issue is not resolved, please open a new BZ and link to the existing one.

Note You need to log in before you can comment on or make changes to this bug.